--- old/usr/src/uts/common/fs/zfs/dsl_pool.c	2014-10-16 19:15:50.797452527 +0200
+++ new/usr/src/uts/common/fs/zfs/dsl_pool.c	2014-10-16 19:15:50.803712880 +0200
@@ -1003,12 +1003,12 @@
  */
 
 int
-dsl_pool_hold(const char *name, void *tag, dsl_pool_t **dp)
+dsl_pool_hold_lock(const char *name, void *tag, dsl_pool_t **dp, int lock)
 {
 	spa_t *spa;
 	int error;
 
-	error = spa_open(name, &spa, tag);
+	error = spa_open_lock(name, &spa, tag, lock);
 	if (error == 0) {
 		*dp = spa_get_dsl(spa);
 		dsl_pool_config_enter(*dp, tag);
@@ -1016,6 +1016,12 @@
 	return (error);
 }
 
+int
+dsl_pool_hold(const char *name, void *tag, dsl_pool_t **dp)
+{
+	return (dsl_pool_hold_lock(name, tag, dp, 1));
+}
+
 void
 dsl_pool_rele(dsl_pool_t *dp, void *tag)
 {
